@echo off
setlocal EnableDelayedExpansion 

if %1 gtr 1850 (
   if %1 gtr 3480 (
      if %1 gtr 5110 (
         if %1 gtr 6740 (
            if %1 gtr 8370 (
               call :getTokenRange6 %1
            ) else (
               call :getTokenRange5 %1
            )
         ) else (
            call :getTokenRange4 %1
         )
      ) else (
         call :getTokenRange3 %1
      )
   ) else (
      call :getTokenRange2 %1
   )
) else (
   call :getTokenRange1 %1
)
exit /B

:getTokenRange1 numInput
set input=%1
set "$numTokens=1850"
call :DefineForTokens
call :CreateNestedFors
for /F "usebackq tokens=1-31* delims=," %%%$1% in ("data1.txt") do %NestedFors% (
    call :getTokenValue val $!input!
    echo token !input! = !val!
)
exit /B

:getTokenRange2 numInput
set /a input=%1-1850
set "$numTokens=1630"
call :DefineForTokens
call :CreateNestedFors
for /F "usebackq tokens=1-31* delims=," %%%$1% in ("data2.txt") do %NestedFors% (
    call :getTokenValue val $!input!
    echo token !input! = !val!
)
exit /B

:getTokenRange3 numInput
set /a input=%1-3480
set "$numTokens=1630"
call :DefineForTokens
call :CreateNestedFors
for /F "usebackq tokens=1-31* delims=," %%%$1% in ("data3.txt") do %NestedFors% (
    call :getTokenValue val $!input!
    echo token !input! = !val!
)
exit /B

:getTokenRange4 numInput
set /a input=%1-5110
set "$numTokens=1630"
call :DefineForTokens
call :CreateNestedFors
for /F "usebackq tokens=1-31* delims=," %%%$1% in ("data4.txt") do %NestedFors% (
    call :getTokenValue val $!input!
    echo token !input! = !val!
)
exit /B

:getTokenRange5 numInput
set /a input=%1-6740
set "$numTokens=1630"
call :DefineForTokens
call :CreateNestedFors
for /F "usebackq tokens=1-31* delims=," %%%$1% in ("data5.txt") do %NestedFors% (
    call :getTokenValue val $!input!
    echo token !input! = !val!
)
exit /B

:getTokenRange6 numInput
set /a input=%1-8370
set "$numTokens=1630"
call :DefineForTokens
call :CreateNestedFors
for /F "usebackq tokens=1-31* delims=," %%%$1% in ("data6.txt") do %NestedFors% (
    call :getTokenValue val $!input!
    echo token !input! = !val!
)
exit /B

:getTokenValue RtnVar TokenName [Modifiers]
setlocal enableDelayedExpansion
set "token=!%~2!"
for %%. in (.) do endlocal & set "%~1=%%%~3%token%"
exit /B

:DefineForTokens
for /F "tokens=2 delims=:." %%p in ('chcp') do set /A "_cp=%%p, _pages=($numTokens/256+1)*2"
set "_hex= 0 1 2 3 4 5 6 7 8 9 A B C D E F"
call set "_pages=%%_hex:~0,%_pages%%%"
if %$numTokens% gtr 2048 echo Creating FOR tokens variables, please wait . . .
(
   echo FF FE
   for %%P in (%_pages%) do for %%A in (%_hex%) do for %%B in (%_hex%) do echo %%A%%B 3%%P 0D 00 0A 00
) > "%temp%\forTokens.hex.txt"
certutil.exe -decodehex -f "%temp%\forTokens.hex.txt" "%temp%\forTokens.utf-16le.bom.txt" >NUL
chcp 65001 >NUL
type "%temp%\forTokens.utf-16le.bom.txt" > "%temp%\forTokens.utf8.txt"
(for /L %%N in (0,1,%$numTokens%) do set /P "$%%N=")  < "%temp%\forTokens.utf8.txt" 
chcp %_cp% >NUL
del "%temp%\forTokens.*.txt"
for %%v in (_cp _hex _pages) do set "%%v="
exit /B

:CreateNestedFors
setlocal EnableDelayedExpansion
set /A "numTokens=$numTokens-1, mod=numTokens%%31, i=numTokens/31, lim=31"
if %mod% equ 0 set "mod=31"
set "NestedFors="
for /L %%i in (32,31,%numTokens%) do (
   if !i! equ 1 set "lim=!mod!"
   set "NestedFors=!NestedFors! for /F "tokens=1-!lim!* delims=," %%!$%%i! in ("%%!$%%i!") do"
   set /A "i-=1"
)
for /F "delims=" %%a in ("!NestedFors!") do endlocal & set "NestedFors=%%a"
exit /B